Package org.apache.sis.referencing.operation

# Class DefaultTransformation

Object
FormattableObject
AbstractIdentifiedObject
AbstractCoordinateOperation
DefaultTransformation

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Parameterized`, `Deprecable`, `LenientComparable`, `IdentifiedObject`, `CoordinateOperation`, `SingleOperation`, `Transformation`

public class DefaultTransformation extends AbstractCoordinateOperation implements Transformation
A parameterized mathematical operation that transforms coordinates to another CRS with a change of datum. The parameters of a coordinate transformation are empirically derived from data containing the coordinates of a series of points in both coordinate reference systems. This computational process is usually "over-determined", allowing derivation of error (or accuracy) estimates for the transformation. Also, the stochastic nature of the parameters may result in multiple (different) versions of the same coordinate transformation.

This coordinate operation contains an operation method, usually with associated parameter values. In the SIS default implementation, the parameter values are inferred from the math transform. Subclasses may have to override the `SingleOperation​.getParameterValues()` method if they need to provide a different set of parameters.

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself) given to the constructor are also immutable. This means that unless otherwise noted in the javadoc, `Transformation` instances created using only SIS factories and static constants can be shared by many objects and passed between threads without synchronization.

Since:
  0.6
See Also:
  - `DefaultConversion`
  - Serialized Form

Defined in the `sis-referencing` module

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface CoordinateOperation

  `COORDINATE_OPERATION_ACCURACY_KEY, DOMAIN_OF_VALIDITY_KEY, OPERATION_VERSION_KEY, SCOPE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultTransformation(Map<String,?> properties, CoordinateReferenceSystem sourceCRS, CoordinateReferenceSystem targetCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform transform)`
  Creates a coordinate transformation from the given properties.
  `protected`
  `DefaultTransformation(Transformation operation)`
  Creates a new coordinate operation with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultTransformation`
  `castOrCopy(Transformation object)`
  Returns a SIS coordinate operation implementation with the values of the given arbitrary implementation.
  `boolean`
  `equals(Object object, ComparisonMode mode)`
  Compares this coordinate operation with the specified object for equality.
  `Class<? extends Transformation>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.
  `OperationMethod`
  `getMethod()`
  Returns a description of the operation method, including a list of expected parameter names.
  `ParameterDescriptorGroup`
  `getParameterDescriptors()`
  Returns a description of the parameters.
  `ParameterValueGroup`
  `getParameterValues()`
  Returns the parameter values.

  ### Methods inherited from class AbstractCoordinateOperation

  `castOrCopy, computeHashCode, formatTo, getCoordinateOperationAccuracy, getDomainOfValidity, getInterpolationCRS, getLinearAccuracy, getMathTransform, getOperationVersion, getScope, getSourceCRS, getTargetCRS, getWrapAroundChanges, isDefiningConversion`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface CoordinateOperation

  `getCoordinateOperationAccuracy, getDomainOfValidity, getMathTransform, getScope`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface SingleOperation

  `getMethod, getParameterValues`

  ### Methods inherited from interface Transformation

  `getOperationVersion, getSourceCRS, getTargetCRS`

- ## Constructor Details

  - ### DefaultTransformation

    public DefaultTransformation(Map<String,?> properties, CoordinateReferenceSystem sourceCRS, CoordinateReferenceSystem targetCRS, CoordinateReferenceSystem interpolationCRS, OperationMethod method, MathTransform transform)
    Creates a coordinate transformation from the given properties. The properties given in argument follow the same rules than for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `AbstractIdentifiedObject.getName()`
    "identifiers" | `Identifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "coordinateOperationAccuracy" | `PositionalAccuracy` (optionally as array) | `AbstractCoordinateOperation.getCoordinateOperationAccuracy()`
    "domainOfValidity" | `Extent` | `AbstractCoordinateOperation.getDomainOfValidity()`

    Parameters:
      `properties` - the properties to be given to the identified object.
      `sourceCRS` - the source CRS.
      `targetCRS` - the target CRS.
      `interpolationCRS` - the CRS of additional coordinates needed for the operation, or `null` if none.
      `method` - the coordinate operation method (mandatory in all cases).
      `transform` - transform from positions in the source CRS to positions in the target CRS.

  - ### DefaultTransformation

    protected DefaultTransformation(Transformation operation)
    Creates a new coordinate operation with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Parameters:
      `operation` - the coordinate operation to copy.
    See Also:
      - `castOrCopy(Transformation)`

- ## Method Details

  - ### castOrCopy

    public static DefaultTransformation castOrCopy(Transformation object)
    Returns a SIS coordinate operation implementation with the values of the given arbitrary implementation. If the given object is already an instance of `DefaultTransformation`, then it is returned unchanged. Otherwise a new `DefaultTransformation` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other properties contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getInterface

    public Class<? extends Transformation> getInterface()
    Returns the GeoAPI interface implemented by this class. The SIS implementation returns `Transformation​.class`.
    Note for implementers: Subclasses usually do not need to override this method since GeoAPI does not define `Transformation` sub-interface. Overriding possibility is left mostly for implementers who wish to extend GeoAPI with their own set of interfaces.
    Overrides:
      `getInterface` in class `AbstractCoordinateOperation`
    Returns:
      `Transformation​.class` or a user-defined sub-interface.

  - ### getMethod

    public OperationMethod getMethod()
    Returns a description of the operation method, including a list of expected parameter names. The returned object does not contains any parameter value.
    Specified by:
      `getMethod` in interface `SingleOperation`
    Returns:
      a description of the operation method.

  - ### getParameterDescriptors

    public ParameterDescriptorGroup getParameterDescriptors()
    Returns a description of the parameters. The default implementation performs the following choice:
    - If parameter values were specified explicitly at construction time, then the descriptor of those parameters is returned.
    - Otherwise if this method can infer the parameter descriptor from the math transform, then that descriptor is returned.
    - Otherwise fallback on the method parameters.
    Note: the two parameter descriptions (from the `MathTransform` or from the `OperationMethod`) should be very similar. If they differ, it should be only in minor details like remarks, default values or units of measurement.
    Specified by:
      `getParameterDescriptors` in interface `Parameterized`
    Returns:
      a description of the parameters.
    See Also:
      - `DefaultOperationMethod​.getParameters()`
      - `AbstractMathTransform​.getParameterDescriptors()`

  - ### getParameterValues

    public ParameterValueGroup getParameterValues()
    Returns the parameter values. The default implementation performs the following choice:
    - If parameter values were specified explicitly at construction time, then they are returned as an unmodifiable parameter group.
    - Otherwise if this method can infer the parameter values from the math transform, then those parameters are returned.
    - Otherwise throw `UnsupportedImplementationException`.
    Specified by:
      `getParameterValues` in interface `Parameterized`
    Specified by:
      `getParameterValues` in interface `SingleOperation`
    Returns:
      the parameter values.
    Throws:
      `UnsupportedOperationException` - if the parameter values can not be determined for the current math transform implementation.
    See Also:
      - `AbstractMathTransform​.getParameterValues()`

  - ### equals

    public boolean equals(Object object, ComparisonMode mode)
    Compares this coordinate operation with the specified object for equality. If the `mode` argument is `ComparisonMode​.STRICT` or `BY_CONTRACT`, then all available properties are compared including the domain of validity and the scope.
    Specified by:
      `equals` in interface `LenientComparable`
    Overrides:
      `equals` in class `AbstractCoordinateOperation`
    Parameters:
      `object` - the object to compare to `this`.
      `mode` - `STRICT` for performing a strict comparison, or `IGNORE_METADATA` for ignoring properties that do not make a difference in the numerical results of coordinate operations.
    Returns:
      `true` if both objects are equal for the given comparison mode.
    See Also:
      - `AbstractIdentifiedObject​.computeHashCode()`
      - `Utilities​.deepEquals(Object, Object, ComparisonMode)`